/*
 * File cas2doocs.h
 *
 * Authors Philip Duval (DESY)
 *
 * Copyright (c) Deutsches Elektronen-Synchrotron DESY 1992-2023
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#define DOOCS_HEARTBEAT 30
#define CAS2DOOCS_FILE "cas2doocs.csv"


typedef struct
{
  char name[64];
  int code;
  int descriptor;
} ADevInfo;

typedef struct
{
  char tineContext[CONTEXT_NAME_SIZE];
  char tineServer[EXPORT_NAME_SIZE];
  char tineSubsystem[SUBSYSTEM_NAME_SIZE];
  char doocsAlarmServer[CONTEXT_NAME_SIZE+EXPORT_NAME_SIZE+8];
  char doocsFacility[CONTEXT_NAME_SIZE];
  char doocsDevice[EXPORT_NAME_SIZE];
  ADevInfo *devices;
  int ndevices;
  int status;
  int nsent;
  time_t interim;
} DoocsAlmXref;

int SendAlarmToDoocs(AMS *ams,char *type);
int SendInfoToDoocs(char *type,char *server,char *device,int system);
DoocsAlmXref *GetDoocsXRef(char *server);
int SendHeartbeatToDoocs(char *server,int system);
int SendStartupToDoocs(char *server,int system);
int initCas2Doocs(void);

